1.1 Import Razorpay.framework library to Your Project
You can import the Razorpay iOS Custom SDK library using any of these ways: Cocoapod, Manual and Objective-C.Cocoapod
Refer to our Cocoapod pod.Manual
1
Step 1
Download the file and unzip the SDK attachment.
2
Step 2
Open your project in XCode and go to file under Menu and select Add files to “yourproject”.
3
Step 3
Select Razorpay.xcframework in the directory you just unzipped.
4
Step 4
Click on the Copy items if needed checkbox.
5
Step 5
Click Add.
Objective-C
If you are building an Objective-C project, follow the steps given for Swift and the additional steps given below:- Go to Project Settings and select Build Settings - All and Combined.
- Set the Always Embed Swift Standard Libraries option to TRUE.
Xcode 11
Ensure that you have the framework added in Frameworks, Libraries, and Embed Content under Target settings - General. ChangeEmbed status from - Do not Embed to Embed & Sign.
Watch the GIF to see how to add Frameworks, Libraries and Embed Content.
1.2 Initialise Razorpay iOS Custom SDK
To initialise the Razorpay SDK:- API key. You can generate this from the Dashboard.
Initialise the Razorpay SDK only with API KeyTo render your UI based on the available payment methods, initialise the Razorpay SDK only with the API key and call getPaymentMethods.To use the SDK initialisation mentioned above, call the following method using the previously created Razorpay instance on any other page where you wish to initiate the payment through the authorise method.
ViewController.swift
ViewController.swift
1.3 Create an Order in Server
Order is an important step in the payment process.- An order should be created for every payment.
- You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
- The
order_idreceived in the response should be passed to the checkout. This ties the order with the payment and secures the request from being tampered.
Handy TipsUnder the Authorization section in Postman, select Basic Auth and add the Key Id and secret as the Username and Password, respectively.
API Sample Code
Use this endpoint to create an order using the Orders API./ordersCurl
Success Response
Request Parameters
amount mandatory
: integer Payment amount in the smallest currency subunit. For example, if the amount to be charged is 299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY and three decimal currencies, such as KWD, BHD and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
first_payment_min_amount optional
: integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of 7000 is to be received from the customer in two installments of #1 - 5000, #2 - 2000 then you can set this value as 500000. This parameter should be passed only if partial_payment is true.Know more about Orders API.Response Parameters
Descriptions for the response parameters are present in the Orders Entity parameters table.Error Response Parameters
The error response parameters are available in the API Reference Guide.1.4 Get Payment Methods
You can accept payments through UPI, credit/debit cards, netbanking and wallets, depending on the methods enabled for your account. When you use Razorpay iOS Standard SDK, you do not have to handle the availability of different payment methods. However, when creating a custom checkout form, ensure the display of only the methods activated for your account to the customer. To get a list of available payment methods, callgetPaymentMethods. This fetches the list of payment methods asynchronously and returns the results.
ViewController.swift
For Subscriptions
If you use your iOS app to receive subscription payments, you must pass thesubscription_id in options to fetch the relevant payment methods. This is because Subscription payments are supported only by select banks and cards.
ViewController.swift
Get Subscription Amount
You can get the subscription amount against the subscription ID using the following function:ViewController.swift
1.5 Initiate Payment
Once you receive the required input from the customer, pass them to our SDK, which takes them to the appropriate authentication channel. Add the following code where you want to initiate payment:ViewController.swift
UPI Intent
For UPI Intent requests, use the following dictionary and pass it to theauthorize function as shown below:
ViewController.swift
ViewController.m
razorpay is an instance of Razorpay.
- When you initiate a UPI Intent payment, the SDK will present a list of UPI apps installed on the device.
- The customer selects their preferred UPI app.
- The customer is redirected to the selected app to complete the authentication.
- After successful authentication, the customer is redirected back to your app.
UPI Collect Requests
Restricted MCC Codes
MCC Code | Category
5816 | Digital Goods: Games
6540 | POI Funding Transactions (excluding MoneySend)
4812 | Telecommunication Equipment and Telephone Sales
4814 | Telecommunication Services
7408 | Lending Platform
6513 | Real Estate Agents and Managers - Rentals
7995 | Betting/Lottery
5412 | Grocery Stores, Supermarkets
5413 | Grocery Stores, Supermarkets Below is a complete list of Checkout form parameters:key mandatory
: string API Key ID generated from Dashboard → Account & Settings → API Keys.
amount mandatory
: integer The amount to be paid by the customer in currency subunits. For example, if the amount is 100, enter 10000. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
description optional
: string Description of the product shown in the Checkout form. It must start with an alphanumeric character.image optional
: string Link to an image (usually your business logo) shown in the Checkout form. Can also be a base64 string, if loading the image from a network is not desirable.order_id mandatory
: string Order ID generated via the Orders API.notes optional
: object Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).method mandatory
: string The payment method used by the customer on Checkout.
Possible values:card(default)upi(default)netbanking(default)wallet(default)emi(default)cardless_emi(requires approval)paylater(requires approval)emandate(requires approval)
card mandatory if method=card/emi
: object The details of the card that should be entered while making the payment.number
: integer Unformatted card number.name
: string The name of the cardholder.expiry_month
: integer Expiry month for card in MM format.expiry_year
: integer Expiry year for card in YY format.cvv
: integer CVV printed on the back of the card.Handy Tips
- CVV is not required by default for tokenised cards across all networks.
- CVV is optional for tokenised card payments. Do not pass dummy CVV values.
-
To implement this change, skip passing the
cvvparameter entirely, or pass anullor empty value in the CVV field. - We recommend removing the CVV field from your checkout UI/UX for tokenised cards.
-
If CVV is still collected for tokenised cards and the customer enters a CVV, pass the entered CVV value to Razorpay.
emi_duration:integerDefines the number of months in the EMI plan.
bank_account mandatory if method=emandate
: The details of the bank account that should be passed in the request. These details include bank account number, IFSC code and the name of the customer associated with the bank account.account_number
: string Bank account number used to initiate the payment.ifsc
: string IFSC of the bank used to initiate the payment.name
: string Name associated with the bank account used to initiate the payment.bank mandatory if method=netbanking
: string Bank code. List of available banks enabled for your account can be fetched via methods.wallet mandatory if method=wallet
: string Wallet code for the wallet used for the payment. Possible values:payzapp(default)olamoney(requires approval)phonepe(requires approval)airtelmoney(requires approval)mobikwik(requires approval)jiomoney(requires approval)amazonpay(requires approval)paypal(requires approval)phonepeswitch(requires approval)
provider mandatory if method=cardless_emi/paylater
: string Name of the cardless EMI provider partnered with Razorpay.Available options for Cardless EMI (requires approval):hdfcicicidfbkkbkzestmoneyearlysalarywalnut369
lazypaypaypal
vpa mandatory if method=upi
: string UPI ID used for making the payment on the UPI app.Handy Tips
- The
notesfield is a read-only field associated with payment and is returned while fetching payment details. Razorpay cannot modify this field. You can add up to 15notesthat will then be associated with the payment. For example:"notes[internal_key_1]", "notes[internal_key_2]"). Razorpay returns this when you fetch payment details from the API. - The
emioption is available only for certain banks. To check the right banks, valid duration and EMI rates/plans to display to the user, please visit the EMI Demopage and click EMI in the payment form. You can safely cache this data at your end since this does not change without prior notification. Calculate the monthly EMI or cache using the following formula:
1.6 Pass WKNavigationDelegate actions to SDK
SDK handles the responses from WKWebView to give you the correct status of the payment.ViewController.swift
1.7 Handle Success and Error Events
This is done by implementing theonPaymentSuccess and onPaymentError methods of the RazorpayPaymentCompletionProtocol.
We recommend giving the user an option to cancel the payment midway and pass on this action. You may also implement a retry action or display a relevant message at this step based on your use case.
ViewController.swift
payment_id that you can use later to capture the payment.
1.8 Store the Fields in Server
A successful payment returns the following fields to the Checkout form.Success Callback
- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
Success Callback
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.
razorpay_order_id
: string Unique identifier for the order returned by Checkout.
razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.
1.9 Verify Payment Signature
This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments.To verify the razorpay_signature returned to you by the Checkout form:
-
Create a signature in your server using the following attributes:
order_id: Retrieve theorder_idfrom your server. Do not use therazorpay_order_idreturned by Checkout.razorpay_payment_id: Returned by Checkout.key_secret: Available in your server. Thekey_secretthat was generated from the Dashboard.
-
Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct a HMAC hex digest as shown below:HMAC Hex Digest -
If the signature you generate on your server matches the
razorpay_signaturereturned to you by the Checkout form, the payment received is from an authentic source.
Generate Signature on Your Server
Given below is the sample code for payment signature verification:Java
Post Signature Verification
After you have completed the integration, you can set up webhooks, make test payments, replace the test key with the live key and integrate with other APIs. Handy Tips iOS 9 has higher requirements for secure URLs. As many Indian banks do not comply with the requirements, you can implement the following as a workaround:info.plist
info.plist file. For more information click here.
1.10 Verify Payment Status
Handy TipsOn the Razorpay Dashboard, ensure that the payment status is
captured. Refer to the payment capture settings page to know how to capture payments automatically.You can track the payment status in three ways:
To verify the payment status from the Razorpay Dashboard:- Log in to the Razorpay Dashboard and navigate to Transactions → Payments.
- Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
Example
If you have subscribed to theorder.paid webhook event, you will receive a notification every time a customer pays you for an order.
Poll Payment APIs to check the payment status.